! netcdf_io.f90 - netCDF abstract I/O
! vi: set ts=8 sw=4:
! Copyright (C) TOYODA Eizi, 2000.  All rights reserved. 

module netcdf_io

    use netcdf_slice
    implicit none

    !
    ! functions defined here return pointer to 6-dimensional array.
    !

    interface getchars
	module procedure NetcdfGetChars
    end interface

!    interface getint
!	module procedure NetcdfGetInt
!    end interface
!
!    interface getreal
!	module procedure NetcdfGetReal
!    end interface
!
contains

    function NetcdfGetChars(var, limit) result(result)
	character, pointer::			result(:, :, :, :, :, :)
	type(NC_VARIABLE), intent(in)::		var
	type(NC_LIMIT), intent(in), optional::	limit
	type(NC_LIMIT)::			mylimit
	integer::				stat
	integer, dimension(NC_SLICE_DIMS)::	d
    continue
	if (present(limit)) then
	    mylimit = limit
	else
	    mylimit = WholeVariable(var)
	endif
	d = count(mylimit)
	allocate(result(d(1), d(2), d(3), d(4), d(5), d(6)), stat=stat)
	if (stat /= 0) then
	    nullify(result); return
	endif
	call doit(Size(mylimit))
	if (stat /= 0) then
	    nullify(result); return
	endif
    contains
	subroutine doit(len)
	    integer, intent(in)::		len
	    character(len = len)::		buffer
	continue
	    stat = nf_get_vars_text(var%file%id, var%id, start(mylimit), d, &
	    	& stride(mylimit), buffer)
	    result = reshape(transfer(buffer, result), shape(result))
	end subroutine
    end function

end module
